## flint 3.1.3

=== CMakeLists.txt ===
#
# Copyright (C) 2023 Isuru Fernando
# Copyright (C) 2023 Albin Ahlbäck
#
# This file is part of FLINT.
#
# FLINT is free software: you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License (LGPL) as published
# by the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.  See <https://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.22)

if(NOT WIN32)
    message(WARNING "Detected system is not Windows. Please use the Autotools configuration along with the Makefile instead as it is more up-to-date. Read INSTALL.")
endif()

include(CheckCCompilerFlag)
include(CheckCSourceRuns)
include(CheckIPOSupported)
include(FindPkgConfig)

# Source of truth for project version
file(STRINGS VERSION FLINT_VERSION_FULL)
string(REGEX MATCH "([0-9]+\.[0-9]+\.[0-9]+)" _ ${FLINT_VERSION_FULL})
set(FLINT_VERSION ${CMAKE_MATCH_1})

project(flint
  VERSION ${FLINT_VERSION}
  DESCRIPTION "Fast Library for Number Theory"
  HOMEPAGE_URL https://flintlib.org/
  LANGUAGES C CXX)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/configure.ac" CONFIGURE_CONTENTS)
foreach(version in MAJOR MINOR PATCH)
  # Set soname version for the library
  string(REGEX MATCH "FLINT_${version}_SO=([0-9]*)" _ ${CONFIGURE_CONTENTS})
  set(FLINT_${version}_SO ${CMAKE_MATCH_1})
  # Set flint version for the header
  set(FLINT_${version} ${PROJECT_VERSION_${version}})
endforeach()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the type of build" FORCE)
   set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Try to enable the fft_small module
if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
    check_c_compiler_flag("-march=native" HAS_FLAG_GCC_MARCH_NATIVE)
elseif("${CMAKE_C_COMPILER_ID}" MATCHES "MSVC")
    # Check if AVX2 is available
    check_c_compiler_flag("/arch:AVX2" HAS_FLAG_MSVC_AVX2)
endif()

# Build options
option(BUILD_SHARED_LIBS "Build shared libs" on)
option(WITH_NTL "Build tests for NTL interface or not" off)

# Check if strongly ordered memory
set(STRONGLY_ORDERED_CPUS x86_64 x86 i386 i586 AMD64)
if(CMAKE_SYSTEM_PROCESSOR IN_LIST STRONGLY_ORDERED_CPUS)
    message(STATUS "Checking if system is strongly ordered - yes")
    set(FLINT_KNOW_STRONG_ORDER ON)
else()
    message(STATUS "Checking if system is strongly ordered - unsure")
    set(FLINT_KNOW_STRONG_ORDER OFF)
endif()

# Find dependencies
find_package(PkgConfig REQUIRED)
pkg_check_modules(GMP REQUIRED IMPORTED_TARGET gmp>=6.2.1)
pkg_check_modules(MPFR REQUIRED IMPORTED_TARGET mpfr>=4.1.0)
if (WITH_NTL)
    find_package(NTL REQUIRED)
endif()
find_package(Python REQUIRED)

find_package(CBLAS)
set(FLINT_USES_BLAS ${CBLAS_FOUND})

if(CMAKE_BUILD_TYPE STREQUAL Debug)
  set(FLINT_WANT_ASSERT ON)
endif()

# pthread configuration

if(MSVC)
    # Prefer vcpkg's pthreads
    find_package(PThreads4W)
    if(PThreads4W_FOUND)
        set(PThreads_LIBRARIES PThreads4W::PThreads4W)
        set(PThreads_INCLUDE_DIRS ${PThreads4W_INCLUDE_DIRS})
    else()
        find_package(PThreads REQUIRED)
    endif()
    set(FLINT_USES_PTHREAD ON CACHE BOOL "Use POSIX Threads.")
else()
    option(CMAKE_THREAD_PREFER_PTHREAD "Prefer pthreads" yes)
    option(THREADS_PREFER_PTHREAD_FLAG "Prefer -pthread flag" yes)
    find_package(Threads REQUIRED)
    set(PThreads_LIBRARIES Threads::Threads)
    set(FLINT_USES_PTHREAD ON CACHE BOOL "Use POSIX Threads.")
endif()


# Check if fft_small module is available
message(STATUS "Checking whether fft_small module is available")
set(CMAKE_REQUIRED_INCLUDES ${GMP_INCLUDE_DIRS})
if(HAS_FLAG_GCC_MARCH_NATIVE)
    set(CMAKE_REQUIRED_FLAGS "-march=native")
elseif(HAS_FLAG_MSVC_AVX2)
    set(CMAKE_REQUIRED_FLAGS "/arch:AVX2")
endif()
check_c_source_compiles([[
    #include <gmp.h>
    #if GMP_LIMB_BITS != 64
    # error
    error
    #endif

    #include <arm_neon.h>
    #if !(defined(__GNUC__) && defined(__ARM_NEON))
    # if !(defined(_MSC_VER) && defined(_M_ARM64))
    #  error
    error
    # endif
    #endif
    void main(){};]] FLINT_FFT_SMALL_ARM)
check_c_source_compiles([[
    #include <gmp.h>
    #if GMP_LIMB_BITS != 64
    # error
    error
    #endif

    #if defined(__GNUC__)
    # include <x86intrin.h>
    #elif defined(_MSC_VER)
    # include <intrin.h>
    #else
    # error
    error
    #endif

    #if !defined(__AVX2__)
    # error
    error
    #endif
    void main(){};]] FLINT_FFT_SMALL_X86)
unset(CMAKE_REQUIRED_INCLUDES)
unset(CMAKE_REQUIRED_FLAGS)

if(FLINT_FFT_SMALL_ARM OR FLINT_FFT_SMALL_X86)
    message(STATUS "Checking whether fft_small module is available - yes")
    set(FFT_SMALL fft_small)
    set(FLINT_HAVE_FFT_SMALL ON)
else()
    message(STATUS "Checking whether fft_small module is available - no")
    set(FFT_SMALL)
endif()

# Find sources

set(_BUILD_DIRS
    generic_files
    thread_pool                     thread_support

    ulong_extras
    long_extras
    perm
    double_extras   d_vec           d_mat
    mpn_extras
    mpfr_vec                        mpfr_mat
    nmod            nmod_vec        nmod_mat        nmod_poly
    fmpz            fmpz_vec        fmpz_mat        fmpz_poly
    fmpz_mod        fmpz_mod_vec    fmpz_mod_mat    fmpz_mod_poly
    fmpq            fmpq_vec        fmpq_mat        fmpq_poly

    fq              fq_vec          fq_mat          fq_poly
    fq_nmod         fq_nmod_vec     fq_nmod_mat     fq_nmod_poly
    fq_zech         fq_zech_vec     fq_zech_mat     fq_zech_poly
    fq_default                      fq_default_mat  fq_default_poly
    fq_embed
    fq_nmod_embed
    fq_zech_embed
    padic                           padic_mat       padic_poly
    qadic

    nmod_poly_factor                fmpz_factor
    fmpz_poly_factor                fmpz_mod_poly_factor
    fq_poly_factor                  fq_nmod_poly_factor
    fq_zech_poly_factor             fq_default_poly_factor

    nmod_poly_mat                   fmpz_poly_mat

    mpoly           nmod_mpoly      fmpz_mpoly      fmpz_mod_mpoly
    fmpq_mpoly      fq_nmod_mpoly   fq_zech_mpoly

    nmod_mpoly_factor               fmpz_mpoly_factor
    fmpz_mod_mpoly_factor           fmpq_mpoly_factor
    fq_nmod_mpoly_factor            fq_zech_mpoly_factor

    fft             ${FFT_SMALL}    fmpz_poly_q     fmpz_lll
    n_poly          arith           qsieve          aprcl

    nf              nf_elem         qfb

    double_interval dlog
    fmpz_extras     fmpzi
    bool_mat        partitions
    mag
    arf             acf             arb             acb
    arb_mat         arb_poly        arb_calc        arb_hypgeom
    acb_mat         acb_poly        acb_calc        acb_hypgeom
    arb_fmpz_poly   arb_fpwrap
    acb_dft         acb_elliptic    acb_modular     acb_dirichlet
    acb_theta       dirichlet       bernoulli       hypgeom

    gr              gr_generic      gr_vec          gr_mat
    gr_poly         gr_mpoly        gr_special

    calcium
    fmpz_mpoly_q
    fexpr           fexpr_builtin
    qqbar
    ca              ca_ext          ca_field        ca_vec
    ca_poly         ca_mat

)
string(REGEX REPLACE "([A-Za-z0-9_-]+;|[A-Za-z0-9_-]+$)" "src/\\1" BUILD_DIRS "${_BUILD_DIRS}")

# NOTE: Template directories are not supposed to be used.

set(_HEADERS
    NTL-interface.h flint.h longlong.h flint-config.h gmpcompat.h fft_tuning.h
    profiler.h templates.h mpf-impl.h
)
string(REGEX REPLACE "([A-Za-z0-9_-]+\.h;|[A-Za-z0-9_-]+\.h$)" "src/\\1" HEADERS "${_HEADERS}")

# Setup for flint-config.h
check_c_compiler_flag("-mpopcnt" HAS_FLAG_MPOPCNT)
check_c_compiler_flag("-funroll-loops" HAS_FLAG_UNROLL_LOOPS)

# fenv configuration
check_c_source_compiles([[#include <fenv.h>
  #ifndef FE_DOWNWARD
  # error FE_DOWNWARD not available
  #endif
  void main(){};]] FLINT_USES_FENV)

# cpu_set_t configuration
set(CMAKE_REQUIRED_FLAGS "${PThreads_LIBRARIES}")
check_c_source_compiles([[#define _GNU_SOURCE
  #include <sched.h>
  #include <pthread.h>
  int main() { cpu_set_t s; CPU_ZERO(&s);
  pthread_getaffinity_np(pthread_self(), sizeof(cpu_set_t), 0);
  return 0; }]] FLINT_USES_CPUSET)
unset(CMAKE_REQUIRED_FLAGS)

# Thread-local storage configuration
set(FLINT_USES_TLS ON CACHE BOOL "Use thread local storage.")

# Memory manager configuration
set(MEMORY_MANAGER "single" CACHE STRING "The FLINT memory manager.")
set_property(CACHE MEMORY_MANAGER PROPERTY STRINGS single reentrant gc)
message(STATUS "Using FLINT memory manager: ${MEMORY_MANAGER}")

if(MEMORY_MANAGER STREQUAL "reentrant")
	set(FLINT_REENTRANT ON)
else()
	set(FLINT_REENTRANT OFF)
endif()

# gmpcompat.h configuration
set(CMAKE_REQUIRED_INCLUDES ${GMP_INCLUDE_DIRS})
check_c_source_compiles([[#include <gmp.h>
  #ifndef _LONG_LONG_LIMB
  # error mp_limb_t != unsigned long long limb
  #endif
  void main(){};]] LONG_LONG_LIMB)

# Populate headers
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/CMake/cmake_config.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/src/flint-config.h
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/flint.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/src/flint.h
)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/fmpz/link/fmpz_${MEMORY_MANAGER}.c
    ${CMAKE_CURRENT_SOURCE_DIR}/src/fmpz/fmpz.c
    COPYONLY
)
if(LONG_LONG_LIMB)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat-longlong.h.in
        ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat.h
        COPYONLY
    )
else()
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat.h.in
        ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat.h
        COPYONLY
    )
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning64.in
        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning.h
        COPYONLY
    )   
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning32.in
        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning.h
        COPYONLY
    )
endif()


foreach (build_dir IN LISTS BUILD_DIRS)
    file(GLOB TEMP RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${build_dir}/*.c")
    list(APPEND SOURCES ${TEMP})
    file(GLOB TEMP RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" "${build_dir}/*.h")
    list(APPEND HEADERS ${TEMP})
endforeach ()

set(TEMP ${HEADERS})
set(HEADERS )
foreach(header IN LISTS TEMP)
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${header})
        list(APPEND HEADERS ${header})
    else()
        list(APPEND HEADERS ${CMAKE_CURRENT_BINARY_DIR}/${header})  
    endif()
endforeach()

file(GLOB TEMP "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h")
list(APPEND HEADERS ${TEMP})

add_library(flint ${SOURCES})
target_link_libraries(flint PUBLIC
    PkgConfig::GMP PkgConfig::MPFR ${PThreads_LIBRARIES})

if(FLINT_USES_BLAS)
    target_link_libraries(flint PUBLIC ${CBLAS_LIBRARIES})
endif()

# Include directories

target_include_directories(flint PUBLIC 
    ${CMAKE_CURRENT_SOURCE_DIR}/src ${GMP_INCLUDE_DIRS} ${MPFR_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR} ${PThreads_INCLUDE_DIRS})

if(FLINT_USES_BLAS)
    target_include_directories(flint PUBLIC ${CBLAS_INCLUDE_DIRS})
endif()

if(BUILD_SHARED_LIBS AND MSVC)
    # Export all functions automatically (except global data)
    set_target_properties(flint PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
    # Export flint's global data that are marked manually
    target_compile_definitions(flint PRIVATE "FLINT_BUILD_DLL")
endif()

if (HAS_FLAG_MPOPCNT)
    target_compile_options(flint PUBLIC "-mpopcnt")
endif()
if (HAS_FLAG_UNROLL_LOOPS)
    target_compile_options(flint PUBLIC "-funroll-loops")
endif()

if(HAS_FLAG_GCC_MARCH_NATIVE)
    target_compile_options(flint PUBLIC "-march=native")
elseif(HAS_FLAG_MSVC_AVX2)
    target_compile_options(flint PUBLIC "/arch:AVX2")
endif()

# Versioning

set_target_properties(flint PROPERTIES

=== debian/changelog ===
flint (3.1.3-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/builtin-overflow.patch
    - New patch; use integer overflow builtins on armhf (Closes: #1091291).

 -- Doug Torrance <dtorrance@debian.org>  Sun, 05 Jan 2025 08:31:12 -0500

flint (3.1.3-1) unstable; urgency=medium

  * Drop unneeded stanza from debian/copyright.
  * Bump standards-version to 4.7.0.
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 09 Jun 2024 15:52:16 +0200

flint (3.1.2-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 02 Apr 2024 16:19:18 -0400

flint (3.1.2-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * debian/control
    - Rename libflint18t64 -> libflint19 (Closes: #1067226).
    - Add Breaks/Replaces for libflint18t64, but only for version 3.1.0 or
      greater, where soversion 19 first appeared.
  * debian/libflint19.install
    - Rename from libflint18t64.install
  * debian/libflint18t64.lintian-overrides
    - Remove file; no longer necessary now that the package name matches
      the soname.
  * debian/libflint18t64.shlibs
    - Remove file; generated automatically by debhelper.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 26 Mar 2024 13:30:18 -0400

flint (3.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 15 Mar 2024 12:15:07 +0100

flint (3.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064626

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 08:46:24 +0000

=== debian/control ===
Source: flint
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Homepage: http://www.flintlib.org/
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               latexmk,
               libgmp-dev,
               libmpfr-dev,
               libntl-dev (>= 9.9.1),
               lmodern, tex-gyre,
               python3-sphinx,
               texlive-fonts-recommended,
               texlive-latex-extra
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/math-team/flint
Vcs-Git: https://salsa.debian.org/math-team/flint.git

Package: libflint19
Replaces: libflint18t64 (>= 3.1.0)
Breaks: libflint18t64 (>= 3.1.0)
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C library for number theory, shared library
 The Fast Library for Integer Number Theory is a C library which supports
 polynomial arithmetic over the integers, fast integer arithmetic and factoring
 (including a highly optimized quadratic sieve).
 .
 FLINT has functionality similar to that of the Number Theory Library (NTL).
 However, unlike NTL, which is designed primarily for asymptotic performance,
 FLINT is designed for good performance in small cases as well.
 .
 This package contains the FLINT shared library.

Package: libflint-dev
Section: libdevel
Architecture: any
Depends: libflint19 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
Description: C library for number theory, development files
 The Fast Library for Integer Number Theory is a C library which supports
 polynomial arithmetic over the integers, fast integer arithmetic and factoring
 (including a highly optimized quadratic sieve).
 .
 FLINT has functionality similar to that of the Number Theory Library (NTL).
 However, unlike NTL, which is designed primarily for asymptotic performance,
 FLINT is designed for good performance in small cases as well.
 .
 This package contains the FLINT development files.

Package: libflint-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Recommends: libflint-dev
Description: Documentation for the FLINT library
 The Fast Library for Integer Number Theory is a C library which supports
 polynomial arithmetic over the integers, fast integer arithmetic and factoring
 (including a highly optimized quadratic sieve).
 .
 FLINT has functionality similar to that of the Number Theory Library (NTL).
 However, unlike NTL, which is designed primarily for asymptotic performance,
 FLINT is designed for good performance in small cases as well.
 .
 This package contains the FLINT documentation

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
CONFIGURE_FLAGS = --=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
endif

MAKE_OVERRIDE = AT= QUIET_CXX= QUIET_CC= QUIET_AR= \
		INCS='-I$(CURDIR) -I$(CURDIR)/build' ABI_FLAG='$(LDFLAGS)'

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with sphinxdoc

override_dh_auto_build:
	dh_auto_build --parallel -- $(MAKE_OVERRIDE)
	make -C doc html
	make -C doc latexpdf

override_dh_auto_install:
	dh_auto_install
	find . -name libflint.a -delete

override_dh_auto_test:
	dh_auto_test -- $(MAKE_OVERRIDE)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf config.status libtool src/config.h src/flint.h doc/build

## flint 3.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,13 +13,13 @@
 cmake_minimum_required(VERSION 3.22)
 
 if(NOT WIN32)
-    message(WARNING "Detected system is not Windows. Please use the Autotools configuration along with the Makefile instead as it is more up-to-date. Read INSTALL.")
+    message(FATAL_ERROR "Detected system is not Windows.  Please use the Autotools configuration along with the Makefile instead as it is more up-to-date.  Read INSTALL.md.")
 endif()
 
 include(CheckCCompilerFlag)
 include(CheckCSourceRuns)
 include(CheckIPOSupported)
-include(FindPkgConfig)
+include(CMakePackageConfigHelpers)
 
 # Source of truth for project version
 file(STRINGS VERSION FLINT_VERSION_FULL)
@@ -48,17 +48,52 @@
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
 endif()
 
-# Try to enable the fft_small module
-if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang" OR "${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
-    check_c_compiler_flag("-march=native" HAS_FLAG_GCC_MARCH_NATIVE)
-elseif("${CMAKE_C_COMPILER_ID}" MATCHES "MSVC")
-    # Check if AVX2 is available
-    check_c_compiler_flag("/arch:AVX2" HAS_FLAG_MSVC_AVX2)
-endif()
+set(CMAKE_C_STANDARD 11)
+set(CMAKE_C_STANDARD_REQUIRED TRUE)
 
 # Build options
 option(BUILD_SHARED_LIBS "Build shared libs" on)
 option(WITH_NTL "Build tests for NTL interface or not" off)
+
+# MSVC has no equivalent to "-march=<arch>"
+if(NOT MSVC)
+    set(ENABLE_ARCH "native" CACHE STRING "Enable and push -march=ARCH option to C compiler")
+    if(NOT "${ENABLE_ARCH}" STREQUAL "NO")
+        check_c_compiler_flag("-march=${ENABLE_ARCH}" HAS_FLAG_ARCH)
+    endif()
+endif()
+
+if(MSVC)
+    set(avx2_flag "/arch:AVX2")
+else()
+    set(avx2_flag "-mavx2")
+endif()
+check_c_compiler_flag("${avx2_flag}" HAS_FLAG_AVX2)
+
+option(ENABLE_AVX2 "Enable AVX2 instructions" ${HAS_FLAG_AVX2})
+option(ENABLE_AVX512 "Enable AVX512 instructions" OFF)
+
+# Check if AVX2 is available
+
+if(ENABLE_AVX2)
+    if(HAS_FLAG_AVX2)
+        check_c_compiler_flag("-mfma" HAS_FLAG_MFMA)
+    else()
+        message(FATAL_ERROR "${CMAKE_C_COMPILER}} does not support the flag ${avx2_flag} needed for AVX2 instructions")
+    endif()
+endif()
+
+if(ENABLE_AVX512)
+    if(MSVC)
+        set(avx512_flag "/arch:AVX512")
+    else()
+        set(avx512_flag "-mavx512f")
+    endif()
+    check_c_compiler_flag("${avx512_flag}" HAS_FLAG_AVX512)
+    if(NOT HAS_FLAG_AVX512)
+        message(FATAL_ERROR "${CMAKE_C_COMPILER}} does not support the flag ${avx512_flag} needed for AVX512 instructions")
+    endif()
+endif()
 
 # Check if strongly ordered memory
 set(STRONGLY_ORDERED_CPUS x86_64 x86 i386 i586 AMD64)
@@ -71,9 +106,12 @@
 endif()
 
 # Find dependencies
-find_package(PkgConfig REQUIRED)
-pkg_check_modules(GMP REQUIRED IMPORTED_TARGET gmp>=6.2.1)
-pkg_check_modules(MPFR REQUIRED IMPORTED_TARGET mpfr>=4.1.0)
+set(GMP_MIN_VERSION 6.2.1)
+find_package(gmp ${GMP_MIN_VERSION} REQUIRED)
+
+set(MPFR_MIN_VERSION 4.1.0)
+find_package(mpfr ${MPFR_MIN_VERSION} REQUIRED)
+
 if (WITH_NTL)
     find_package(NTL REQUIRED)
 endif()
@@ -106,14 +144,14 @@
     set(FLINT_USES_PTHREAD ON CACHE BOOL "Use POSIX Threads.")
 endif()
 
-
 # Check if fft_small module is available
 message(STATUS "Checking whether fft_small module is available")
-set(CMAKE_REQUIRED_INCLUDES ${GMP_INCLUDE_DIRS})
-if(HAS_FLAG_GCC_MARCH_NATIVE)
-    set(CMAKE_REQUIRED_FLAGS "-march=native")
-elseif(HAS_FLAG_MSVC_AVX2)
-    set(CMAKE_REQUIRED_FLAGS "/arch:AVX2")
+set(CMAKE_REQUIRED_LIBRARIES gmp::gmp)
+if(HAS_FLAG_ARCH)
+    set(CMAKE_REQUIRED_FLAGS "-march=${ENABLE_ARCH}")
+endif()
+if(ENABLE_AVX2)
+    set(CMAKE_REQUIRED_FLAGS "${avx2_flag}")
 endif()
 check_c_source_compiles([[
     #include <gmp.h>
@@ -173,9 +211,11 @@
     long_extras
     perm
     double_extras   d_vec           d_mat
+    nfloat
     mpn_extras
     mpfr_vec                        mpfr_mat
     nmod            nmod_vec        nmod_mat        nmod_poly
+    mpn_mod
     fmpz            fmpz_vec        fmpz_mat        fmpz_poly
     fmpz_mod        fmpz_mod_vec    fmpz_mod_mat    fmpz_mod_poly
     fmpq            fmpq_vec        fmpq_mat        fmpq_poly
@@ -236,7 +276,7 @@
 # NOTE: Template directories are not supposed to be used.
 
 set(_HEADERS
-    NTL-interface.h flint.h longlong.h flint-config.h gmpcompat.h fft_tuning.h
+    NTL-interface.h flint.h longlong.h flint-config.h gmpcompat.h flint-mparam.h
     profiler.h templates.h mpf-impl.h
 )
 string(REGEX REPLACE "([A-Za-z0-9_-]+\.h;|[A-Za-z0-9_-]+\.h$)" "src/\\1" HEADERS "${_HEADERS}")
@@ -277,12 +317,28 @@
 endif()
 
 # gmpcompat.h configuration
-set(CMAKE_REQUIRED_INCLUDES ${GMP_INCLUDE_DIRS})
+set(CMAKE_REQUIRED_LIBRARIES gmp::gmp)
 check_c_source_compiles([[#include <gmp.h>
   #ifndef _LONG_LONG_LIMB
   # error mp_limb_t != unsigned long long limb
   #endif
-  void main(){};]] LONG_LONG_LIMB)
+  void main(){};]] FLINT_LONG_LONG)
+
+check_c_source_compiles([[#include <gmp.h>
+  #if GMP_LIMB_BITS == 32
+  # error
+  #endif
+  void main(){};]] FLINT64)
+
+if(FLINT64)
+    set(FLINT_BITS 64)
+else()
+    set(FLINT_BITS 32)
+endif()
+
+if(MSVC AND NOT BUILD_SHARED_LIBS)
+    set(FLINT_STATIC_BUILD 1)
+endif()
 
 # Populate headers
 configure_file(
@@ -298,7 +354,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/src/fmpz/fmpz.c
     COPYONLY
 )
-if(LONG_LONG_LIMB)
+if(FLINT_LONG_LONG)
     configure_file(
         ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat-longlong.h.in
         ${CMAKE_CURRENT_SOURCE_DIR}/src/gmpcompat.h
@@ -314,16 +370,10 @@
 
 if(CMAKE_SIZEOF_VOID_P EQUAL 8)
     configure_file(
-        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning64.in
-        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning.h
+        ${CMAKE_CURRENT_SOURCE_DIR}/src/mpn_extras/generic/flint-mparam.h
+        ${CMAKE_CURRENT_SOURCE_DIR}/src/flint-mparam.h
         COPYONLY
     )   
-elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
-    configure_file(
-        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning32.in
-        ${CMAKE_CURRENT_SOURCE_DIR}/src/fft_tuning.h
-        COPYONLY
-    )
 endif()
 
 
@@ -349,42 +399,9 @@
 
 add_library(flint ${SOURCES})
 target_link_libraries(flint PUBLIC
-    PkgConfig::GMP PkgConfig::MPFR ${PThreads_LIBRARIES})
-
-if(FLINT_USES_BLAS)
-    target_link_libraries(flint PUBLIC ${CBLAS_LIBRARIES})
-endif()
-
-# Include directories
-
-target_include_directories(flint PUBLIC 
-    ${CMAKE_CURRENT_SOURCE_DIR}/src ${GMP_INCLUDE_DIRS} ${MPFR_INCLUDE_DIRS}
-    ${CMAKE_CURRENT_BINARY_DIR} ${PThreads_INCLUDE_DIRS})
-
-if(FLINT_USES_BLAS)
-    target_include_directories(flint PUBLIC ${CBLAS_INCLUDE_DIRS})
-endif()
-
-if(BUILD_SHARED_LIBS AND MSVC)
-    # Export all functions automatically (except global data)
-    set_target_properties(flint PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS ON)
-    # Export flint's global data that are marked manually
-    target_compile_definitions(flint PRIVATE "FLINT_BUILD_DLL")
-endif()
-
-if (HAS_FLAG_MPOPCNT)
-    target_compile_options(flint PUBLIC "-mpopcnt")
-endif()
-if (HAS_FLAG_UNROLL_LOOPS)
-    target_compile_options(flint PUBLIC "-funroll-loops")
-endif()
-
-if(HAS_FLAG_GCC_MARCH_NATIVE)
-    target_compile_options(flint PUBLIC "-march=native")
-elseif(HAS_FLAG_MSVC_AVX2)
-    target_compile_options(flint PUBLIC "/arch:AVX2")
-endif()
-
-# Versioning
-
-set_target_properties(flint PROPERTIES
+    gmp::gmp
+    mpfr::mpfr
+    ${PThreads_LIBRARIES}
+)
+
+if(MSVC AND NOT "${CMAKE_CXX_SIMULATE_ID}" STREQUAL "MSVC")

=== doc/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -j=auto
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = flint
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
flint (3.3.1-2) unstable; urgency=medium

  * debian/rules
    - Build with -fno-strict-aliasing to fix FTBFS when compiling with
      GCC 15 (Closes: #1114011).
  * debian/salsa-ci.yml
    - New file; disable reprotest for now.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 05 Sep 2025 07:29:07 -0400

flint (3.3.1-1) unstable; urgency=medium

  * Upload to unstable for libflint19 -> libflint21 transition.

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Drop unnecessary dh arguments: --parallel

  [ John Scott ]
  * Update the DEP-8 test for clarity and to use newly-introduced
    functionality.

  [ Doug Torrance ]
  * debian/control
    - Add myself to Uploaders
    - Bump Standards-Version to 4.7.2.
  * debian/copyright
    - Add my copyright info to debian/* stanza.
  * debian/patches/builtin-overflow.patch
    - Restore patch as a workaround for another "not enough registers"
      compilation error on armhf that was introduced in the new release.
  * debian/patches/verbose-builds.patch
    - New patch; allow verbose builds with V make variable.
  * debian/rules
    - Update MAKE_OVERRIDE variable whose value is passed to make; include
      new V variable for verbose builds and remove old now-unused variables.
  * debian/tests/control
    - Drop strict aliasing when compiling test program; not an issue after
      the update.
  * debian/tests/matrix-bernoulli.c
    - Add header for rational vectors
  * debian/watch
    - Update url.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 03 Sep 2025 09:56:05 -0400

flint (3.3.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - Fixes GCC 15 build issues (Closes: #1096641, #1107362).
  * Upload to experimental for soversion bump transition.
  * Rename libflint19 -> libflint21 for soversion bump.
  * debian/control
    - Drop Breaks/Replaces for libflint18t64; no longer necessary.
  * debian/copyright
    - Replace old postal FSF address with url.
  * debian/libflint-doc.*
    - Update name of pdf documentation file.
  * debian/patches/builtin-overflow.patch
    - Remove patch; issue fixed upstream.
  * debian/patches/local-mathjax.patch
    - Refresh for new release.
  * debian/tests/control
    - Compile test program with strict aliasing as workaround for upstream
      bug.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 27 Aug 2025 12:22:44 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: math
 Priority: optional
 Maintainer: Debian Math Team <team+math@tracker.debian.org>
-Uploaders: Julien Puydt <jpuydt@debian.org>
-Homepage: http://www.flintlib.org/
+Uploaders: Julien Puydt <jpuydt@debian.org>,
+           Doug Torrance <dtorrance@debian.org>
+Homepage: https://www.flintlib.org/
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                latexmk,
                libgmp-dev,
@@ -13,14 +14,12 @@
                python3-sphinx,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint
 Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint19
-Replaces: libflint18t64 (>= 3.1.0)
-Breaks: libflint18t64 (>= 3.1.0)
+Package: libflint21
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -39,7 +38,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint19 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint21 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring

=== debian/rules ===
--- 
+++ 
@@ -8,16 +8,18 @@
 CONFIGURE_FLAGS = --=$(DEB_HOST_GNU_CPU)-$(DEB_HOST_ARCH_OS) CC=$(CC) CXX=$(CXX) AR=$(AR)
 endif
 
-MAKE_OVERRIDE = AT= QUIET_CXX= QUIET_CC= QUIET_AR= \
-		INCS='-I$(CURDIR) -I$(CURDIR)/build' ABI_FLAG='$(LDFLAGS)'
+export MAKE_OVERRIDE = V=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# https://github.com/flintlib/flint/issues/2340
+export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
 
 %:
 	dh $@ --with sphinxdoc
 
 override_dh_auto_build:
-	dh_auto_build --parallel -- $(MAKE_OVERRIDE)
+	dh_auto_build -- $(MAKE_OVERRIDE)
 	make -C doc html
 	make -C doc latexpdf

=== debian/tests/control ===
Test-Command: gcc debian/tests/matrix-bernoulli.c -o "$AUTOPKGTEST_TMP"/matrix-bernoulli -lflint && "$AUTOPKGTEST_TMP"/matrix-bernoulli
Depends: gcc, libc-dev, libflint-dev

=== debian/watch ===
version=4
https://github.com/flintlib/flint/tags .*/v?(\d[-\d.]*)\.tar\.gz

## flint 3.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -213,7 +213,6 @@
     double_extras   d_vec           d_mat
     nfloat
     mpn_extras
-    mpfr_vec                        mpfr_mat
     nmod            nmod_vec        nmod_mat        nmod_poly
     mpn_mod
     fmpz            fmpz_vec        fmpz_mat        fmpz_poly
@@ -238,7 +237,7 @@
     nmod_poly_mat                   fmpz_poly_mat
 
     mpoly           nmod_mpoly      fmpz_mpoly      fmpz_mod_mpoly
-    fmpq_mpoly      fq_nmod_mpoly   fq_zech_mpoly
+    fmpq_mpoly      fq_nmod_mpoly   fq_zech_mpoly   fmpz_mod_mpoly_q
 
     nmod_mpoly_factor               fmpz_mpoly_factor
     fmpz_mod_mpoly_factor           fmpq_mpoly_factor
@@ -261,7 +260,7 @@
     acb_theta       dirichlet       bernoulli       hypgeom
 
     gr              gr_generic      gr_vec          gr_mat
-    gr_poly         gr_mpoly        gr_special
+    gr_poly         gr_mpoly        gr_series       gr_special
 
     calcium
     fmpz_mpoly_q
@@ -277,7 +276,7 @@
 
 set(_HEADERS
     NTL-interface.h flint.h longlong.h flint-config.h gmpcompat.h flint-mparam.h
-    profiler.h templates.h mpf-impl.h
+    profiler.h templates.h
 )
 string(REGEX REPLACE "([A-Za-z0-9_-]+\.h;|[A-Za-z0-9_-]+\.h$)" "src/\\1" HEADERS "${_HEADERS}")

=== debian/changelog ===
flint (3.4.0-1) unstable; urgency=medium

  * Source-only upload for transition to testing.
  * Upload to unstable.  (The previous version was supposed to go to
    experimental but ended up in unstable for some reason.)

 -- Doug Torrance <dtorrance@debian.org>  Wed, 26 Nov 2025 23:30:38 -0500

flint (3.4.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Rename libflint21 -> libflint22 for soversion bump
  * Upload to experimental ahead of soversion bump transition.
  * debian/control
    - Drop redundant Rules-Requires-Root field.
  * debian/patches/builtin-overflow.patch
    - Update bug url.
  * debian/patches/verbose-build.patch
    - Remove patch; applied upstream

 -- Doug Torrance <dtorrance@debian.org>  Wed, 26 Nov 2025 05:33:24 -0500

=== debian/control ===
--- 
+++ 
@@ -15,11 +15,10 @@
                texlive-fonts-recommended,
                texlive-latex-extra
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint
 Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint21
+Package: libflint22
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -38,7 +37,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint21 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint22 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
